;****************************************************************************************
;*                           SCHRITT-MOTOR VON DL3UKH                                   *
;*                           ========================                                   *
;*                                                                                      *
;*--------------------------------------------------------------------------------------*
;*                                                                                      *
;* ALS PIC-IC WURDE GENOMMEN PIC16F88                                                   *
;* ALS OSZILLATOR WURDE EIN QUARZ MIT 16,00MHZ GENOMMEN. (T=0.0625SEC ALSO DIE TAKTZEIT) *
;****************************************************************************************

        LIST    P=16F88       
        TITLE   "SCHRITTMOTOR"

        ERRORLEVEL -302
        INCLUDE <P16F88.INC>

__CONFIG _CONFIG1, _CP_OFF & _CCPMX_RB0 & _DEBUG_OFF & _WRT_OFF & _CPD_OFF & _LVP_OFF & _BOREN_OFF & _MCLRE_OFF & _PWRTE_OFF & _WDTE_OFF & _HS_OSC
__CONFIG _CONFIG2, _IESO_OFF & _FCMEN_OFF



;--------------------------------------------------------------------------
;REGISTER ZUORDNEN NACH DEM DIE FESTEN-REGISTER ZU ENDE SIND
;ES GEHT ALSO ERST AB 22 HEX LOS
;DIES IST ALSO DIE RAM-SPEICHER ZUORDNUNG


W_STACK                 EQU     0X22
S_STACK                 EQU     0X23

HELP                    EQU     0X24        ;HILFSZELLE FUER ZEITSCHLEIFEN
AD_H                    EQU     0X25        ;AD-ZELLE
AD_L                    EQU     0X26        ;AD-ZELLE
POSITION                EQU     0X27        ;SCHRITT-POSITION                    
ZAE                     EQU     0X28        ;ZAEHLER FUER SCHRITTE
DREHRICHTUNG            EQU     0X29        ;DREHRICHTUNG VOR + RCKWAERTS BIT0
START                   EQU     0X2A        ;STOP(HIGH) ODER START(LOW) [STRART-BIT0] DURCH INTERRUPT AN RB0

STELLUNG_POTI           EQU     0X2B        ;POTI-STELLUNG GEMESSEN AUS AD UND BESCHNITTEN / AM ANFANG BIS FEHLT
STELLUNG_MOTOR          EQU     0X2C        ;MOTORSTELLUNG
          
BREMSE                  EQU     0X2D        ;BREMS-MERKER BIT0 HIGH BREMST ES                    
EINMAL                  EQU     0X2E        ;SCHALTER-ABFRAGE
           
;--------------------------- VARIABLEN -------------------------------------
BIT7                    EQU     7       ; BIT 7
BIT6                    EQU     6       ; BIT 6
BIT5                    EQU     5       ; BIT 5
BIT4                    EQU     4       ; BIT 4
BIT3                    EQU     3       ; BIT 3 
BIT2                    EQU     2       ; BIT 2
BIT1                    EQU     1       ; BIT 1 
BIT0                    EQU     0       ; BIT 0
                    
SPULE_A                 EQU     5       ;RA0-A_  RA1-A  -->PORTA ENTSPRICHT DEZ. 5
SPULE_B                 EQU     5       ;RA3-B   RA2-B_ -->AUCH PORTA          

                 
 ;--------------------------------------------------------------------------                 
;HIER KOENNTE MAN AENDERN
                 
;MAN KANN ZAHLEN VON D'1' BIS D'255' EINTRAGEN
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
                 
;WURDE GEMACHT UM STROM IM BREMS-ZUSTAND ZU SPAREN 
;MAN MUSS PROBIEREN OB ES TROTZDEM NOCH GENUEGEND BREMST // SIEHE LETZTES BEISPIEL
;ES GEHT HIER AUCH DIE D'0' NULL EINZUTRAGEN.
;ES WIRKT DIESE EINSTELLUNG NUR WENN POTI NICHT AKTIV IST / JUMPER NICHT GESETZT
                 
;ANDERES BEISPIEL :                  
;BREMS_STROM_EIN         EQU     D'10'    ;BREMST VOLLSTAENDIG    
;BREMS_STROM_AUS         EQU     D'0'

;ANDERES BEISPIEL :          
BREMS_STROM_EIN         EQU     D'0'     ;BREMST UEBERHAUPT NICHT    
BREMS_STROM_AUS         EQU     D'10' 

;ANDERES BEISPIEL :         
;BREMS_STROM_EIN         EQU     D'8'    ;8MSEC LANG FLIESST STROM DURCH DIE ZWEI SPULEN / ES BREMST / 
;BREMS_STROM_AUS         EQU     D'2'    ;2MSEC LANG FLIESST KEIN STROM DURCH DIE ZWEI SPULEN / ES BREMST NICHT / 
 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
                         
;JUSTAGE ZEIT ODER EINSTELL-POSITIONIERUNGS-STELL-ZEIT BEI DAUERDRUCK BEI VOR UND ZURUECK // RECHTS ODER LINKS
JUSTAGE                 EQU     D'200'  ;200MSEC *2 (IMMER MAL 2) = 400MSEC / ALLER 400MSEC MACHT ES EINEN SCHRITT WEITER BEIM JUSTIEREN DER STELLUNG
                 
                 
;--------------------------------------------------------------------------                 
;ALLGEMEINES TEMPO BEI POTI VERSTELLEN // ALSO SCHRITT-MOTOR-GESCHWINDIGKEIT                
TEMPO                   EQU     D'10'   ;ALLER 10MSEC EIN SCHRITT ---> ALSO WIE SCHNELL STELLEN BEI VERDREHEN / EINSTELLEN DES POTIS
                                                                      ;BEI 5MSEC TRATEN SCHRITT-FEHLER BEI MIR AUF
                                                                      ;ES VERLOR SCHRITTE
    
                  
;--------------------------------------------------------------------------

;------------------------- MACROS -----------------------------------------

BANK0           MACRO                   ;MACRO TO SELECT DATA RAM BANK 0
                BCF     STATUS,RP0
                BCF     STATUS,RP1
                ENDM

BANK1           MACRO                   ;MACRO TO SELECT DATA RAM BANK 1
                BSF     STATUS,RP0
                BCF     STATUS,RP1
                ENDM

BANK2           MACRO                   ;MACRO TO SELECT DATA RAM BANK 2
                BCF     STATUS,RP0
                BSF     STATUS,RP1
                ENDM

BANK3           MACRO                   ;MACRO TO SELECT DATA RAM BANK 3
                BSF     STATUS,RP0
                BSF     STATUS,RP1
                ENDM

PUSH    MACRO
        MOVWF   W_STACK
        MOVF    STATUS, W
        MOVWF   S_STACK
        ENDM

POP     MACRO
        MOVF    S_STACK, W
        MOVWF   STATUS
        SWAPF   W_STACK, F
        SWAPF   W_STACK, W
        ENDM
;----------------------------------------------------------------------------


;----------------------------------------------------------------------------
;-----------------------------------------------------------------------------

;SPEICHERANFANG BZW. BEGINN

                ORG 0X0000
                GOTO MAIN               ; SPRUNG ZUM HAUPTPROGRAMM
                ORG 0X0004
                RETFIE                  ; BEI EINEM INTERRUPT

                ORG 0X0010

;*****************************************************************************
;*                            HAUPTPROGRAMM                                  *
;*****************************************************************************
;PORT-INITIALISIERUNG
MAIN            CLRF    PORTA                           
                CLRF    PORTB

                BANK1
                MOVLW   B'00001000'
                MOVWF   OSCCON

                MOVLW   0X07                    ;COMPARATORS ALLE AUS VOM PORT A
                MOVWF   CMCON

                MOVLW   B'11110000'             ;INIT INPUT/OUTPUT AM PORTA BIT4-7 EINGANG / BEI 1 EINGANG  6+7 SIND QUARZ / RA4 IST AD4 / RA0 BIS RA3 AUSGANG HIER DIE 0 ALS AUSGANG
                MOVWF   TRISA
                MOVLW   B'00001111'             ;INIT I/O PORTB  RB0 BIS RB3 ALS EINGAENG MIT DER 1 /// RB4 BIS RB7 AUSGANG MIT DER 0
                MOVWF   TRISB

;INIT TIMER 0 FUER 1MSEC
                MOVLW   B'10000111'             ;BIT0-2 1=PRESCALER256, BIT3 0=TMR0, BIT4 0=ENTFAELLT, BIT5 0=TAKT VOM SYSTEM, BIT6 0=KEIN RB-INTERRUPT, BIT7 1=PULL-UPS DISABLE 
                MOVWF   OPTION_REG
                
;AD-INIT
                MOVLW   B'00010000'  ;RA4 ALS AD4
                MOVWF   ANSEL
;AD-INIT
                MOVLW   B'10000000'             ;RECHTSBNDIG B1 / FOSZ=32 B0 / VSS+VDD REF-SPANNUNG B00
                MOVWF   ADCON1
                BANK0
;AD-INIT
                MOVLW   B'10100001'             ;FOSZ=32 B10 / AD4 B100 / GO-IST AUS + ON IST EIN B001
                MOVWF   ADCON0
       
                BCF     PORTB, BIT4             ;LED AUS
                BCF     PORTB, BIT5             ;PIEPSER AUS                           
 

;50MSEC ZEITSCHLEIFE
                MOVLW   D'50'                   ;ZEITSCHLEIFE LADEN IN W MIT DEZIMAL 50 ALSO---> 50*1MSEC=50MSEC
                CALL    ZS1MSEC                 ;ZEITSCHLEIFE ABARBEITEN

;INIT DREHEN / STELLEN --> ANFANGSWERTE                
                MOVLW   B'00000001'             ;ANFANGSWERT MIT BIT0 HIGH
                MOVWF   POSITION
                CLRF    SPULE_A
                ;CLRF    SPULE_B KANN MAN WEGLASSEN DA AUCH PORTA

                MOVLW   D'1'
                MOVWF   STELLUNG_MOTOR
                
                CLRF    ZAE
                
                GOTO    BE_END
                
                
                
BEGIN
                ;MOVF    ZAE, W
                ;SUBLW   D'0'
                ;BTFSC   STATUS, Z
                BTFSS   ZAE, BIT0
                GOTO    BE_END 
                
                BTFSC   DREHRICHTUNG, BIT0
                GOTO    BE_RUECKWAERTS

;;;;;;;;;;;;;;;;;;                
BE_VORWAERTS
          
                CALL    STELLEN_VORWAERTS
                GOTO    BE_END 
           
;;;;;;;;;;;;;;;;;;              
BE_RUECKWAERTS
       
                CALL    STELLEN_RUECKWAERTS
                GOTO    BE_END 
 
;;;;;;;;;;;;;;;;;                
BE_END 
                MOVLW   TEMPO 
                CALL    ZS1MSEC_BREMSE
                CALL    AD
                GOTO    BEGIN
          
                
                
;*****************************************************************************
;*                              AD-WANDLUNG MIT ZEITSCHLEIFE                 *
;*****************************************************************************
AD
                BCF    PIR1, ADIF 

                BSF     ADCON0, GO_DONE     ;GEHT LOS
                MOVLW   D'50'
                CALL    ZS1MUE              ;ZEITSCHLEIFE 50SEC 
                                            ;BEI ZEITSCHLEIFE WEGLASSEN GEHT ES NICHT EXAKT!!!

AD01            BTFSS  PIR1, ADIF           ;WENN ADIF HIGH=1 IST HAT ES GEMESSEN UND IST FERTIG !
                GOTO   AD01                 ;ES GEHT DANN WEITER IM PROGRAMM

;ANALOG/DIGITAL-WANDLUNG STOPPEN
                BCF     ADCON0, GO_DONE    
                
;AD-ERGEBNIS ABSPEICHERN IN RAM-ZELLEN AD_H UND AD_L
                MOVF    ADRESH, W
                MOVWF   AD_H
                BANK1                               
                MOVF    ADRESL, W
                BANK0                               
                MOVWF   AD_L

;---------
;1024 ZU 256 DEZ. MACHEN
                BCF     STATUS, C
                RRF     AD_H, F         ;ZU 512MAX.
                RRF     AD_L, F

                BCF     STATUS, C
                RRF     AD_H, F         ;ZU 256MAX.
                RRF     AD_L, F

                ;BCF     STATUS, C
                ;RRF     AD_H, F         ;ZU 128MAX.
                ;RRF     AD_L, F

                ;BCF     STATUS, C
                ;RRF     AD_H, F         ;ZU 64MAX.
                ;RRF     AD_L, F

                MOVLW    0X00
                SUBWF    AD_L, W
                BTFSS    STATUS, Z
                GOTO     RECH00

                INCF     AD_L, F      ;UM EINS ERHHEN ALSO 0X01 FR AD_L --->WENN NULL
                
                
RECH00                    
                MOVLW    D'201'
                SUBWF    AD_L, W
                BTFSS   STATUS, C
                GOTO    RECH001         ;AD_L KLEINER D201 /// DA SCHRITT-BEGINN AB D'1'
                                 
                MOVLW   D'201'
                MOVWF   AD_L            ;AD_L GROESSER UND GLEICH D201
                
RECH001                     
                MOVF    AD_L, W
                MOVWF   STELLUNG_POTI
                
RECH01          
                MOVF    STELLUNG_MOTOR, W
                SUBWF   STELLUNG_POTI, W
                BTFSS   STATUS, Z
                GOTO    RECH02
                MOVLW   D'0'
                MOVWF   ZAE
                RETURN
                
RECH02                
                MOVF    STELLUNG_MOTOR, W
                SUBWF   STELLUNG_POTI, W
                BTFSS   STATUS, C
                GOTO    RECH03              ;KLEINER STELLUNG_POTI
                
                MOVLW   D'1'                ;GROESSER STELLUNG_POTI
                MOVWF   ZAE
                INCF    STELLUNG_MOTOR, F
                
                BSF     DREHRICHTUNG, BIT0
                RETURN
                
RECH03                
                MOVLW   D'1'                ;GROESSER STELLUNG_MOTOR
                MOVWF   ZAE
                DECF    STELLUNG_MOTOR, F
                
                BCF     DREHRICHTUNG, BIT0
                RETURN                
                
                                  
;*****************************************************************************
;*                              VORWAERTS STELLEN                            *
;*****************************************************************************
STELLEN_VORWAERTS
                BCF     STATUS, C
                RLF     POSITION, F
                
;UEBERLAUF LINKS
BREMS00         BTFSS   POSITION, BIT4
                GOTO    ST00
                BSF     POSITION, BIT0
                
ST00            BTFSS   POSITION, BIT0
                GOTO    ST01
                BCF     SPULE_A, BIT0
                BSF     SPULE_A, BIT1
                BCF     SPULE_B, BIT2
                BSF     SPULE_B, BIT3
                RETURN               
                
ST01            BTFSS   POSITION, BIT1
                GOTO    ST02
                BSF     SPULE_A, BIT0
                BCF     SPULE_A, BIT1
                BCF     SPULE_B, BIT2
                BSF     SPULE_B, BIT3
                RETURN     
                 
ST02            BTFSS   POSITION, BIT2
                GOTO    ST03
                BSF     SPULE_A, BIT0
                BCF     SPULE_A, BIT1
                BSF     SPULE_B, BIT2
                BCF     SPULE_B, BIT3
                RETURN                    
                
ST03            BTFSS   POSITION, BIT3
                RETURN
                BCF     SPULE_A, BIT0
                BSF     SPULE_A, BIT1
                BSF     SPULE_B, BIT2
                BCF     SPULE_B, BIT3
                RETURN                   
                
;*****************************************************************************
;*                              RUECKWAERTS STELLEN                          *
;*****************************************************************************
STELLEN_RUECKWAERTS
                BCF     STATUS, C
                RRF     POSITION, F
                
;UEBERLAUF RECHTS
                BTFSS   STATUS, C
                GOTO    RST00
                BSF     POSITION, BIT3
                
RST00           BTFSS   POSITION, BIT0
                GOTO    RST01
                BCF     SPULE_A, BIT0
                BSF     SPULE_A, BIT1
                BCF     SPULE_B, BIT2
                BSF     SPULE_B, BIT3
                RETURN               
                
RST01           BTFSS   POSITION, BIT1
                GOTO    RST02
                BSF     SPULE_A, BIT0
                BCF     SPULE_A, BIT1
                BCF     SPULE_B, BIT2
                BSF     SPULE_B, BIT3
                RETURN     
                 
RST02           BTFSS   POSITION, BIT2
                GOTO    RST03
                BSF     SPULE_A, BIT0
                BCF     SPULE_A, BIT1
                BSF     SPULE_B, BIT2
                BCF     SPULE_B, BIT3
                RETURN                    
                
RST03           BTFSS   POSITION, BIT3
                RETURN
                BCF     SPULE_A, BIT0
                BSF     SPULE_A, BIT1
                BSF     SPULE_B, BIT2
                BCF     SPULE_B, BIT3
                RETURN                   
 
                
; SCHRITT-AUSGABE :
; SPULE_A BIT1    SPULE_B BIT3    SPULE_A BIT0   SPULE_B BIT2
; 1               1               0              0                  SCHRITT 1   POSITION-BIT0
; 0               1               1              0                  SCHRITT 2   POSITION-BIT1
; 0               0               1              1                  SCHRITT 3   POSITION-BIT2
; 1               0               0              1                  SCHRITT 4   POSITION-BIT3
; RA1             RA3             RA0            RA2
                
; SPULE_A RA1+RA0    
; SPULE_B RA3+RA2                

;*****************************************************************************
;*                              1MSEC ZEITSCHLEIFE                           *
;*****************************************************************************
ZS1MSEC_BREMSE          MOVWF   HELP

ZS111                   MOVLW   D'240'
                        MOVWF   TMR0                    
                        BCF     INTCON, TMR0IF          
                
ZS121                   BTFSC   INTCON, TMR0IF
                        GOTO    ZS131

                        
BREMS                   BTFSS   PORTB, BIT3     ;SCHALTER-AUSWERTUNG
                        GOTO    BREMS002        ;AD-WANDUNG EIN // BREMSE AUS // JUSTIEREN EIN
                        GOTO    BREMS0002       ;AD-WANDLUNG AUS // BREMSE+JUSTIEREN EIN
                        
BREMS01                 BTFSS   PORTB, BIT2     ;VORWAERTS STELLEN
                        GOTO    RUECK01
                        BTFSS   PORTB, BIT1     ;RUECKWAERTS STELLEN
                        GOTO    VOR01
                        BTFSC   BREMSE, BIT0
                        GOTO    BREMSEN01
 
                        GOTO    ZS121                    

ZS131                   DECFSZ  HELP, F                 
                        GOTO    ZS111                    

                        RETURN
                        
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;                        
BREMSEN01       MOVLW   BREMS_STROM_EIN ;MOTOR-STOP BREMSE
                SUBLW   D'0'
                BTFSC   STATUS, Z
                GOTO    BREMSXXX

                CALL    BREMS00
                MOVLW   BREMS_STROM_EIN
                CALL    ZS1MSEC
                
BREMSXXX        MOVLW   BREMS_STROM_AUS
                SUBLW   D'0'
                BTFSC   STATUS, Z
                GOTO    BREMS
                
                BCF     SPULE_A, BIT0   
                BCF     SPULE_A, BIT1
                BCF     SPULE_B, BIT2
                BCF     SPULE_B, BIT3
                MOVLW   BREMS_STROM_AUS
                CALL    ZS1MSEC

                GOTO    BREMS
                
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;  
BREMS0002       BTFSC   EINMAL, BIT0
                GOTO    BREMS01
                
                BSF     EINMAL, BIT0
                BSF     BREMSE, BIT0        ;BREMSE EIN // AD-WANDLUNG AUS
                BCF     PORTB, BIT4         ;LED AUS
                GOTO    BREMS01
                
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;                
BREMS002       BTFSS   EINMAL, BIT0        
                GOTO    BREMS01
                
                BCF     EINMAL, BIT0                       
                BCF     BREMSE, BIT0        ;BREMSE AUS // AD-WANDLUNG EIN     
                BSF     PORTB, BIT4         ;LED EIN
                                
                CALL    BREMS00
                MOVLW   D'1'
                CALL    ZS1MSEC_BREMSE
                
                GOTO    BREMS01
                
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;  
                
RUECK01
                CALL    STELLEN_RUECKWAERTS
                MOVLW   JUSTAGE
                CALL    ZS1MSEC
                MOVLW   JUSTAGE
                CALL    ZS1MSEC
                GOTO    BREMS
                
                
VOR01
                CALL    STELLEN_VORWAERTS
                MOVLW   JUSTAGE
                CALL    ZS1MSEC
                MOVLW   JUSTAGE
                CALL    ZS1MSEC              
                GOTO    BREMS
                                
                   
;*****************************************************************************
;*                              1MSEC ZEITSCHLEIFE                           *
;*****************************************************************************
ZS1MSEC                 MOVWF   HELP

ZS11                    MOVLW   D'240'
                        MOVWF   TMR0                    
                        BCF     INTCON, TMR0IF          
                
ZS12                    BTFSS   INTCON, TMR0IF           
                        GOTO    ZS12                    

                        DECFSZ  HELP, F                 
                        GOTO    ZS11                    

                        RETURN

;ZEITBERECHNUNG FUER 1MS
;PRESCALER 256X  *  SYSTEM 4X  * TAKTZEIT ====> 256*4*0.0625S=64SEC /DIE TAKTZEIT ERGIBT SICH AUS DEM INTERNEN OSZILLATOR
;1MS : 64S= 15,625  GENOMMEN 16                                      /T = 1 : F  (F)-OSZILLATORFREQUENZ HIER 16MHZ
;ALSO 
;64S*D'16'=1,024MSEC
;TMR0 ALSO D'256'-D'16'=D'240' ENTSPRICHT CA. 1MSEC
;240 DEZIMAL OBEN EINTRAGEN

;*****************************************************************************
;*                              1MSEC ZEITSCHLEIFE                           *
;*****************************************************************************
ZS1MUE                  MOVWF   HELP

ZS1                     NOP
                        ;NOP WEG WEGEN GOTO 8T
                        ;NOP
                        ;NOP WEG WEGEN DECFSZ 4T

                        ;BERECHNUNG
                        ;1SEC : (0.0625SEC*4FUER 1MAL NOP) = 4 MAL NOP ---> CA. !!!!
                        
                        DECFSZ  HELP, F                 
                        GOTO    ZS1                     

                        RETURN
                        
                        
                        
                        END











